> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a fulfillment

GET https://rest.test.zuora.com/object-query/fulfillments/{key}

Retrieves a Fulfillment object. You can use the query parameters to filter, expand, and sort the returned results.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/object-query/object-queries/query-fulfillment-by-key

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `key` (string, required) — ID or number of the fulfillment.

### Query parameters

- `pageSize` (integer, optional, default: 10) — The maximum number of results to return in a single page. If the specified `pageSize` is less than 1 or greater than 99, Zuora will return a 400 error.
- `cursor` (string, optional) — A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with `next_page=W3sib3JkZXJ=`, your subsequent call can include `cursor=W3sib3JkZXJ=` in order to fetch the next page of the list.
- `sort[]` (list of string, optional) — A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. `accountnumber.ASC`) or descending (e.g. `accountnumber.DESC`). You cannot sort on properties in arrays. If the array-type properties are specified for the `sort[]` parameter, they are ignored. Supported sortable fields: - updateddate
- `expand[]` (list of string, optional) — Allows you to expand responses by including related object information in a single call.
- `filter[]` (list of string, optional) — A case-insensitive filter on the list. Supported filterable fields: * id * createddate * updateddate * orderlineitemid - fulfillmentnumber * state * externalid * \{indexedcustomfield}: Use the format like `customField__c` to filter on custom fields.
- `fields[]` (list of string, optional) — A case-insensitive query parameter that allows you to specify which fields are returned in the response.
- `includeNullFields` (boolean, optional, default: false) — Specifies whether to include fields with the `null` value in the response. - If set to `true`, all fields will be returned in the response, including those with the `null` value. - If set to `false`, only fields with non-null values will be returned.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

## Response

### 200

OK

- `id` (string, optional) — The unique identifier of the fulfillment.
- `createdById` (string, optional) — The unique identifier of the user who created the fulfillment.
- `createdDate` (datetime, optional) — The date and time when the fulfillment was created.
- `updatedById` (string, optional) — The unique identifier of the user who last updated the fulfillment.
- `updatedDate` (datetime, optional) — The date and time when the fulfillment was last updated.
- `orderLineItemId` (string, optional) — ID of the order line item.
- `fulfillmentNumber` (string, optional) — The sytem generated number for the fulfillment.
- `fulfillmentType` (enum, optional) — The type of the fulfillment.
  - Allowed values: `Delivery`, `Return`
- `fulfillmentDate` (date, optional) — The date of the fulfillment.
- `quantity` (double, optional) — The quantity of the fulfillment.
- `state` (enum, optional) — The state of the fulfillment. See Order Line Item states, Order states, and state transitions for more information.
  - Allowed values: `Executing`, `Booked`, `SentToBilling`, `Complete`, `Cancelled`
- `trackingNumber` (string, optional) — The tracking number of the fulfillment.
- `billTargetDate` (date, optional) — The target date for the fulfillment to be picked up by bill run for billing.
- `description` (string, optional) — The description of the fulfillment.
- `carrier` (string, optional) — The carrier of the fulfillment. The available values can be managed in the Fulfillment Settings page under Billing Settings.
- `fulfillmentLocation` (string, optional) — The location of the fulfillment. The available values can be managed in the Fulfillment Settings page under Billing Settings.
- `fulfillmentSystem` (string, optional) — The system of the fulfillment. The available values can be managed in the Fulfillment Settings page under Billing Settings.
- `externalId` (string, optional) — The external ID of the fulfillment.
- `excludeItemBookingFromRevenueAccounting` (boolean, optional) — The flag to exclude fulfillment item from revenue accounting. **Note**: This field is only available if you have the Order to Revenue or Zuora Billing - Revenue Integration feature enabled.
- `excludeItemBillingFromRevenueAccounting` (boolean, optional) — The flag to exclude fulfillment item from revenue accounting. **Note**: This field is only available if you have the Order to Revenue or Zuora Billing - Revenue Integration feature enabled.

## Errors

### 500 Internal Server Error

Internal server error

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

### 400 Client Request Error

Invalid input

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

## Types

### CommonOqErrorResponseReasonsItems

- `code` (integer, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "id": "8a90f48297fbc4bf01980718bd9a0034",
  "createdById": "a0933229dfcd41f3a977efa52be31667",
  "createdDate": "2025-07-14T12:01:58+08:00",
  "updatedById": "a0933229dfcd41f3a977efa52be31667",
  "updatedDate": "2025-07-14T12:01:58+08:00",
  "orderLineItemId": "8a90ff9297fbc4ee01980714649212d6",
  "fulfillmentNumber": "F-00000166",
  "fulfillmentType": "Delivery",
  "fulfillmentDate": "2025-07-14",
  "quantity": 100,
  "state": "SentToBilling",
  "billTargetDate": "2025-07-14",
  "excludeItemBookingFromRevenueAccounting": false,
  "excludeItemBillingFromRevenueAccounting": false
}
```

**SDK Code**

```python Object Queries_queryFulfillmentByKey_example
import requests

url = "https://rest.test.zuora.com/object-query/fulfillments/key"

querystring = {"fields[]":"[\"id,createddate\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Object Queries_queryFulfillmentByKey_example
const url = 'https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Object Queries_queryFulfillmentByKey_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Object Queries_queryFulfillmentByKey_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Object Queries_queryFulfillmentByKey_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Object Queries_queryFulfillmentByKey_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Object Queries_queryFulfillmentByKey_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Object Queries_queryFulfillmentByKey_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-query/fulfillments/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```